/*************************************************************
Module name: DllWork.h
Written by:  Jeffrey Richter
Purpose:     A DLL that creates multiple threads when loaded
*************************************************************/


// If this file is included by DllWork source code modules,
// DLLWORKAPI will be defined as '__declspec(dllexport)
// All other EXEs and DLLs will import these functions
#ifndef DLLWORKAPI
#define DLLWORKAPI __declspec(dllimport)
#endif


//////////////////////////////////////////////////////////////


// Function prototypes
DLLWORKAPI void ShutdownLibrary();
DLLWORKAPI void SomeFunc();


//////////////////////////////////////////////////////////////


// Useful macro for debugging
#ifdef _DEBUG
#define DebugBox(szText, szCaption) \
   MessageBox(NULL, szText, szCaption, MB_OK)
#else

#define DebugBox(szText, szCaption)

#endif


///////////////////////// End of File ////////////////////////
