////////////////////////////////////////////////////////////////////////////////
// $Header:   S:\3x\src\ntkm\ntdevpp\sampdrv\custdpc.h_v   1.0   24 Jun 1996 16:24:34   JHUCKINS  $
// 
// INTEL Corporation Proprietary Information
// 
// This listing is supplied under the terms of a license agreement
// with INTEL Corporation and may not be copied nor disclosed except
// in accordance with the terms of that agreement.
// 
// Copyright (c) 1996 Intel Corporation. All rights reserved.
// 
// $Revision:   1.0  $
// $Date:   24 Jun 1996 16:24:34  $
// $Author:   JHUCKINS  $
// 
// Log at end of file.
// 
// Module Name:	custdpc.h
// Author:		Jeff Huckins
// Abstract:	CCustomDpcObject Interface
// Environment:	Windows NT 3.51/4.0, MS Visual C++ 4.x
// Notes:
// 
////////////////////////////////////////////////////////////////////////////////

#ifndef custdpc_h
#define custdpc_h

class CCustomDpcObject 
{
public:
	// ctor/dtor
	CCustomDpcObject();
	virtual ~CCustomDpcObject();

	// initialize custom dpc object
	VOID InitializeDpcRequest( 
		IN PKDEFERRED_ROUTINE DeferredRoutine,
		IN PVOID DeferredContext );

	// insert request into dpc queue
	BOOLEAN InsertQueue( 
		IN PVOID SystemArgument1 = NULL,
		IN PVOID SystemArgument2 = NULL );

	// remove request from dpc queue
	BOOLEAN RemoveQueue( VOID );

private:
	// members
	KDPC m_Dpc;
};

////////////////////////////////////////////////////////////////////////////////
// inlines
//
inline CCustomDpcObject::CCustomDpcObject()
{
	return;
}

inline CCustomDpcObject::~CCustomDpcObject()
{
	return;
}

inline VOID CCustomDpcObject::InitializeDpcRequest(
	IN PKDEFERRED_ROUTINE DeferredRoutine,
	IN PVOID DeferredContext )
{
	ASSERT_IRQL_EQ( PASSIVE_LEVEL );
	ASSERT( NULL != DeferredRoutine );
	KeInitializeDpc( &m_Dpc, DeferredRoutine, DeferredContext );
	return;
}

inline BOOLEAN CCustomDpcObject::RemoveQueue( void )
{
	return KeRemoveQueueDpc( &m_Dpc );
}

#endif custdpc_h

/*******************************************************************************
 * $Log:   S:\3x\src\ntkm\ntdevpp\sampdrv\custdpc.h_v  $
 * 
 *    Rev 1.0   24 Jun 1996 16:24:34   JHUCKINS
 * Initial revision.
 * 
 *    Rev 1.7   03 Jun 1996 07:47:08   JHUCKINS
 * Added Author to file header
 * 
 *    Rev 1.6   31 May 1996 15:50:24   JDELLIOT
 * added robustness features (ASSERT, TRACE, validation of params)
 * cleanup
 * restructure of some interfaces
 * 
 *    Rev 1.5   03 May 1996 10:37:56   JHUCKINS
 * Fix recursion bug in InsertQueue()
 * 
 *    Rev 1.4   25 Apr 1996 13:32:58   JHUCKINS
 * Moved InsertQueue() to custdpc.cpp
 * 
 *    Rev 1.3   23 Apr 1996 10:09:26   JHUCKINS
 * m_DeferredContext not needed.
 * 
 *    Rev 1.2   23 Apr 1996 09:03:22   JHUCKINS
 * Set arguments to InsertQueue to be default NULL
 * 
 *    Rev 1.1   22 Apr 1996 14:25:10   JHUCKINS
 * Added inline destructor
 * 
 *    Rev 1.0   12 Apr 1996 13:00:28   JHUCKINS
 * Initial revision.
 */
