////////////////////////////////////////////////////////////////////////////////
// $Header:   S:\3x\src\ntkm\ntdevpp\sampdrv\devqueue.h_v   1.0   24 Jun 1996 16:24:30   JHUCKINS  $
// 
// INTEL Corporation Proprietary Information
// 
// This listing is supplied under the terms of a license agreement
// with INTEL Corporation and may not be copied nor disclosed except
// in accordance with the terms of that agreement.
// 
// Copyright (c) 1996 Intel Corporation. All rights reserved.
// 
// $Revision:   1.0  $
// $Date:   24 Jun 1996 16:24:30  $
// $Author:   JHUCKINS  $
// 
// Log at end of file.
// 
// Module Name:		devqueue.h
// Abstract:		CDeviceQueue Inteface
// Environment:		Windows NT 3.51/4.0, MS Visual C++ 2.x
// Notes:
// 
////////////////////////////////////////////////////////////////////////////////

#ifndef devqueue_h
#define devqueue_h

#include <idrivrpp.h>

////////////////////////////////////////////////////////////////////////////////
// CDeviceQueueEntry Interface
////////////////////////////////////////////////////////////////////////////////
class CDeviceQueueEntry : public _KDEVICE_QUEUE_ENTRY
{
public:
	// ctor/dtor
	CDeviceQueueEntry( IN PVOID Data );
	virtual ~CDeviceQueueEntry( void );

	// methods
	PVOID GetData( void );

private:
	// members
	PVOID m_Data;
};

////////////////////////////////////////////////////////////////////////////////
// inline functions
//
inline CDeviceQueueEntry::CDeviceQueueEntry( IN PVOID Data )
	: m_Data( Data )
{
	return;
}

inline CDeviceQueueEntry::~CDeviceQueueEntry( void )
{
	return;
}

inline PVOID CDeviceQueueEntry::GetData( void )
{
	return m_Data;
}

////////////////////////////////////////////////////////////////////////////////
// CDeviceQueue Interface
////////////////////////////////////////////////////////////////////////////////
class CDeviceQueue
{
public:
	// ctor/dtor
	CDeviceQueue( void );
	virtual ~CDeviceQueue( void );

	// methods
	BOOLEAN Insert( IN CDeviceQueueEntry* DeviceQueueEntry );
	BOOLEAN Insert( IN CDeviceQueueEntry* DeviceQueueEntry, IN ULONG SortKey );
	BOOLEAN InsertData( IN PVOID Data );
	BOOLEAN InsertData( IN PVOID Data, IN ULONG SortKey );
	CDeviceQueueEntry* Remove( void );
	CDeviceQueueEntry* Remove( IN ULONG SortKey );
	PVOID RemoveData( void );
	PVOID RemoveData( IN ULONG SortKey );
	BOOLEAN RemoveEntry( IN CDeviceQueueEntry* DeviceQueueEntry );

private:
	// members
	KDEVICE_QUEUE m_DeviceQueue;
};

#endif devqueue_h

/******************************************************************************
 * $Log:   S:\3x\src\ntkm\ntdevpp\sampdrv\devqueue.h_v  $
 * 
 *    Rev 1.0   24 Jun 1996 16:24:30   JHUCKINS
 * Initial revision.
 * 
 *    Rev 1.2   31 May 1996 15:49:50   JDELLIOT
 * added robustness features (ASSERT, TRACE, validation of params)
 * cleanup
 * restructure of some interfaces
 * 
 *    Rev 1.1   08 May 1996 15:28:56   JDELLIOT
 * added xxxData routines
 * 
 *    Rev 1.0   07 May 1996 14:54:04   JDELLIOT
 * Initial revision.
 * 
 */
