////////////////////////////////////////////////////////////////////////////////
// $Header:   S:\3x\src\ntkm\ntdevpp\sampdrv\dlist.h_v   1.0   24 Jun 1996 16:24:32   JHUCKINS  $
// 
// INTEL Corporation Proprietary Information
// 
// This listing is supplied under the terms of a license agreement
// with INTEL Corporation and may not be copied nor disclosed except
// in accordance with the terms of that agreement.
// 
// Copyright (c) 1996 Intel Corporation. All rights reserved.
// 
// $Revision:   1.0  $
// $Date:   24 Jun 1996 16:24:32  $
// $Author:   JHUCKINS  $
// 
// Log at end of file.
// 
// Module Name:	dlist.h
// Author:		Jeff Huckins
// Abstract:	CDListEntry Interface
// Environment:	Windows NT 3.51/4.0, MS Visual C++ 4.x
// Notes:
// 
////////////////////////////////////////////////////////////////////////////////

#ifndef dlist_h
#define dlist_h

// forward declarations
class CDListEntry;

// list entry typedefs
typedef struct tagMYLIST_ENTRY
{
	LIST_ENTRY Entry;
	CDListEntry* This;
} MYLIST_ENTRY;
typedef MYLIST_ENTRY* PMYLIST_ENTRY;

////////////////////////////////////////////////////////////////////////////////
// CDListEntry Interface
////////////////////////////////////////////////////////////////////////////////
class CDListEntry
{
public:
	// ctor/dtor
	CDListEntry();
	virtual ~CDListEntry();

	// cast operator
	operator PLIST_ENTRY();

private:
	MYLIST_ENTRY	m_Entry;
};

////////////////////////////////////////////////////////////////////////////////
// inlines
//
inline CDListEntry::~CDListEntry()
{
	return;
}

inline CDListEntry::operator PLIST_ENTRY()
{
	return PLIST_ENTRY( &m_Entry );
}

////////////////////////////////////////////////////////////////////////////////
// CDList Interface
////////////////////////////////////////////////////////////////////////////////
class CDList
{
public:
	// ctor/dtor
	CDList();
	virtual ~CDList();

	VOID Initialize( IN CDListEntry& Entry );
	VOID InsertAtHead( IN CDListEntry& Entry );
	VOID InsertAtTail( IN CDListEntry& Entry );
	BOOLEAN IsEmpty( VOID );
	CDListEntry* RemoveAtTail( VOID );

private:
	CDListEntry* m_Head;
};


////////////////////////////////////////////////////////////////////////////////
// inlines
//
inline CDList::CDList()
	:	m_Head( NULL )
{
	return;
}

inline CDList::~CDList()
{
	return;
}

inline VOID CDList::Initialize( IN CDListEntry& Entry )
{
	InitializeListHead( (PLIST_ENTRY) Entry );
	return;
}

inline VOID CDList::InsertAtHead( IN CDListEntry& Entry )
{
	InsertHeadList( (PLIST_ENTRY) *m_Head, (PLIST_ENTRY) Entry );
	return;
}

inline VOID CDList::InsertAtTail( IN CDListEntry& Entry )
{
	InsertTailList( (PLIST_ENTRY) *m_Head, (PLIST_ENTRY) Entry );
	return;
}

inline BOOLEAN CDList::IsEmpty( VOID )
{
	return BOOLEAN( IsListEmpty( (PLIST_ENTRY) *m_Head ) );
}

#endif	// DLIST_H_

/*******************************************************************************
 * $Log:   S:\3x\src\ntkm\ntdevpp\sampdrv\dlist.h_v  $
 * 
 *    Rev 1.0   24 Jun 1996 16:24:32   JHUCKINS
 * Initial revision.
 * 
 *    Rev 1.3   03 Jun 1996 07:47:08   JHUCKINS
 * Added Author to file header
 * 
 *    Rev 1.2   31 May 1996 15:50:16   JDELLIOT
 * added robustness features (ASSERT, TRACE, validation of params)
 * cleanup
 * restructure of some interfaces
 * 
 *    Rev 1.1   04 Apr 1996 09:45:22   JHUCKINS
 * Added IN and OUT macros to formal argument lists
 * 
 *    Rev 1.0   01 Apr 1996 13:16:56   JHUCKINS
 * Initial revision.
 */
