////////////////////////////////////////////////////////////////////////////////
// $Header:   S:\3x\src\ntkm\ntdevpp\sampdrv\dpc.cpv   1.0   24 Jun 1996 16:24:24   JHUCKINS  $
// 
// INTEL Corporation Proprietary Information
// 
// This listing is supplied under the terms of a license agreement
// with INTEL Corporation and may not be copied nor disclosed except
// in accordance with the terms of that agreement.
// 
// Copyright (c) 1996 Intel Corporation. All rights reserved.
// 
// $Revision:   1.0  $
// $Date:   24 Jun 1996 16:24:24  $
// $Author:   JHUCKINS  $
// 
// Log at end of file.
// 
// Module Name:	dpc.cpp
// Author:		Jeff Huckins
// Abstract:	CDpcObject Implementation
// Environment:	Windows NT 3.51/4.0, MS Visual C++ 2.x
// Notes:
// 
////////////////////////////////////////////////////////////////////////////////

// disable some warnings
#pragma warning( disable: 4699 )	// Note: Creating precompiled header
#pragma warning( disable: 4201 )	// nameless struct/union
#pragma warning( disable: 4514 )	// unreferenced inline function has been removed
#pragma warning( disable: 4711 )	// function 'function' selected for automatic inline expansion

#include <idrivrpp.h>
#include "dpc.h"
#include "device.h"

////////////////////////////////////////////////////////////////////////////////
// ctor/dtor
//
CDpcObject::CDpcObject()
{
	return;
}

CDpcObject::~CDpcObject()
{
	return;
}

VOID CDpcObject::InitializeDpcRequest( IN CDeviceObject* DeviceObject )
{
	ASSERT( NULL != DeviceObject );
	IoInitializeDpcRequest( (PDEVICE_OBJECT) *DeviceObject, Dpc );
	return;
}

VOID CDpcObject::Dpc( 
	IN PKDPC /* DpcObject */, 
	IN PDEVICE_OBJECT DeviceObject, 
	IN PIRP Irp, 
	IN PVOID Context )
{
	CDeviceObject* pDevice = (CDeviceObject*) DeviceObject->DeviceExtension;
	ASSERT( NULL != pDevice );

	// call most-derived's OnDpc method
	pDevice->OnDpc( Irp, Context );
	return;
}

////////////////////////////////////////////////////////////////////////////////
// $Log:   S:\3x\src\ntkm\ntdevpp\sampdrv\dpc.cpv  $
// 
//    Rev 1.0   24 Jun 1996 16:24:24   JHUCKINS
// Initial revision.
// 
//    Rev 1.6   03 Jun 1996 07:47:04   JHUCKINS
// Added Author to file header
// 
//    Rev 1.5   31 May 1996 15:49:52   JDELLIOT
// added robustness features (ASSERT, TRACE, validation of params)
// cleanup
// restructure of some interfaces
// 
//    Rev 1.4   04 Apr 1996 09:45:20   JHUCKINS
// Added IN and OUT macros to formal argument lists
// 
//    Rev 1.3   03 Apr 1996 07:29:40   JHUCKINS
// include idrivrpp.h instead of ntdevpp.h so that global operator new and
// delete are defined for all
// 
//    Rev 1.2   27 Mar 1996 14:12:48   JDELLIOT
// added PVCS keywords and support for warning level 4
//

