////////////////////////////////////////////////////////////////////////////////
// $Header:   S:\3x\src\ntkm\ntdevpp\sampdrv\dpc.h_v   1.0   24 Jun 1996 16:24:30   JHUCKINS  $
// 
// INTEL Corporation Proprietary Information
// 
// This listing is supplied under the terms of a license agreement
// with INTEL Corporation and may not be copied nor disclosed except
// in accordance with the terms of that agreement.
// 
// Copyright (c) 1996 Intel Corporation. All rights reserved.
// 
// $Revision:   1.0  $
// $Date:   24 Jun 1996 16:24:30  $
// $Author:   JHUCKINS  $
// 
// Log at end of file.
// 
// Module Name:	dpc.h
// Author:		Jeff Huckins
// Abstract:	CDpcObject Interface
// Environment:	Windows NT 3.51/4.0, MS Visual C++ 2.x
// Notes:
// 
////////////////////////////////////////////////////////////////////////////////

#ifndef dpc_h
#define dpc_h

// forward declarations
class CDeviceObject;

class CDpcObject 
{
public:
	// ctor/dtor
	CDpcObject();
	virtual ~CDpcObject();

	// calls IoInitializeDpcRequest().
	VOID InitializeDpcRequest( IN CDeviceObject* DeviceObject );

private:
	// accesses DeviceObject->DeviceExtension as CDeviceObject* and then calls
	// CDeviceObject::OnDpc(), passing the Context argument through to it.
	static VOID Dpc(
		IN PKDPC DpcObject, 
		IN PDEVICE_OBJECT DeviceObject, 
		IN PIRP Irp, 
		IN PVOID Context );
};

#endif	// dpc_h

/*******************************************************************************
 * $Log:   S:\3x\src\ntkm\ntdevpp\sampdrv\dpc.h_v  $
 * 
 *    Rev 1.0   24 Jun 1996 16:24:30   JHUCKINS
 * Initial revision.
 * 
 *    Rev 1.5   03 Jun 1996 07:47:04   JHUCKINS
 * Added Author to file header
 * 
 *    Rev 1.4   31 May 1996 15:49:54   JDELLIOT
 * added robustness features (ASSERT, TRACE, validation of params)
 * cleanup
 * restructure of some interfaces
 * 
 *    Rev 1.3   04 Apr 1996 09:45:20   JHUCKINS
 * Added IN and OUT macros to formal argument lists
 * 
 *    Rev 1.2   27 Mar 1996 14:12:52   JDELLIOT
 * added PVCS keywords and support for warning level 4
 *
 */

