////////////////////////////////////////////////////////////////////////////////
// $Header:   S:\3x\src\ntkm\ntdevpp\sampdrv\file.cpv   1.0   24 Jun 1996 16:24:26   JHUCKINS  $
// 
// INTEL Corporation Proprietary Information
// 
// This listing is supplied under the terms of a license agreement
// with INTEL Corporation and may not be copied nor disclosed except
// in accordance with the terms of that agreement.
// 
// Copyright (c) 1996 Intel Corporation. All rights reserved.
// 
// $Revision:   1.0  $
// $Date:   24 Jun 1996 16:24:26  $
// $Author:   JHUCKINS  $
// 
// Log at end of file.
// 
// Module Name:	file.cpp
// Author:		Jeff Huckins
// Abstract:	CFile Implementation
// Environment:	Windows NT 3.51/4.0, MS Visual C++ 4.x
// Notes:
//		Intended as a simple wrapper class for the  ZwXxx() file routines.
//		It is also intendeded that the CFile class be a base class for
//		CDeviceFile, which enforces assignment of the optional Apc and Ea
//		arguments to NULL for intermediate and device drivers.
// 
////////////////////////////////////////////////////////////////////////////////

#pragma warning( disable: 4514 )	// unreferenced inline function has been removed
#pragma warning( disable: 4201 )	// nonstandard extension used : nameless struct/union
#pragma warning( disable: 4711 )	// function 'function' selected for automatic inline expansion

#include "idrivrpp.h"
#include "file.h"

////////////////////////////////////////////////////////////////////////////////
// ctor/dtor
//
CFile::CFile()
	:	m_Handle ( NULL )
{
	return;
}

CFile::~CFile()
{
	if( NULL != m_Handle )
	{
		Close();
	}

	return;
}

////////////////////////////////////////////////////////////////////////////////
// methods
//
NTSTATUS CFile::Close( void )
{
	ASSERT_IRQL_EQ( PASSIVE_LEVEL );
	ASSERT( NULL != m_Handle );

	NTSTATUS Status = ZwClose( m_Handle );
	if( NT_SUCCESS( Status ) )
	{
		m_Handle = NULL;
	}

	return Status;
}

////////////////////////////////////////////////////////////////////////////////
// $Log:   S:\3x\src\ntkm\ntdevpp\sampdrv\file.cpv  $
// 
//    Rev 1.0   24 Jun 1996 16:24:26   JHUCKINS
// Initial revision.
// 
//    Rev 1.2   03 Jun 1996 07:47:10   JHUCKINS
// Added Author to file header
// 
//    Rev 1.1   31 May 1996 15:50:28   JDELLIOT
// added robustness features (ASSERT, TRACE, validation of params)
// cleanup
// restructure of some interfaces
// 
