////////////////////////////////////////////////////////////////////////////////
// $Header:   S:\3x\src\ntkm\ntdevpp\sampdrv\mem.cpv   1.0   24 Jun 1996 16:24:26   JHUCKINS  $
// 
// INTEL Corporation Proprietary Information
// 
// This listing is supplied under the terms of a license agreement
// with INTEL Corporation and may not be copied nor disclosed except
// in accordance with the terms of that agreement.
// 
// Copyright (c) 1996 Intel Corporation. All rights reserved.
// 
// $Revision:   1.0  $
// $Date:   24 Jun 1996 16:24:26  $
// $Author:   JHUCKINS  $
// 
// Log at end of file.
// 
// Module Name:	mem.cpp
// Author:		Jeff Huckins
// Abstract:	Implementation for global new() and delete()
// Environment:	Windows NT 3.51/4.0, MS Visual C++ 2.x	
// Notes: 		
// 
////////////////////////////////////////////////////////////////////////////////

// disable some warnings
#pragma warning( disable: 4699 )	// Note: Creating precompiled header
#pragma warning( disable: 4201 )	// nameless struct/union
#pragma warning( disable: 4514 )	// unreferenced inline function has been removed

#include "mem.h"
#include "debug.h"

#ifndef _PNH_DEFINED
typedef int (__cdecl* _PNH)( size_t );
#define _PNH_DEFINED
#endif

int _cdecl __default_nh( size_t )
{
	TRACE( "__default_hh: out of memory in operator new!" );
	return 0;
};

_PNH __newhandler = __default_nh;

_PNH _cdecl _set_new_handler( _PNH handler )
{
	ASSERT( NULL != handler );
	_PNH oldhandler = __newhandler;
	__newhandler = handler;

	return oldhandler;
}

PVOID _cdecl operator new( size_t size )
{
	return ExAllocatePool( NonPagedPool, size );
}

PVOID _cdecl operator new( size_t size, POOL_TYPE type )
{
	return ExAllocatePool( type, size );
}

VOID _cdecl operator delete( PVOID p )
{
	ASSERT( NULL != p );
	ExFreePool( p );
}

////////////////////////////////////////////////////////////////////////////////
// $Log:   S:\3x\src\ntkm\ntdevpp\sampdrv\mem.cpv  $
// 
//    Rev 1.0   24 Jun 1996 16:24:26   JHUCKINS
// Initial revision.
// 
//    Rev 1.6   03 Jun 1996 07:47:06   JHUCKINS
// Added Author to file header
// 
//    Rev 1.5   31 May 1996 15:50:10   JDELLIOT
// added robustness features (ASSERT, TRACE, validation of params)
// cleanup
// restructure of some interfaces
// 
//    Rev 1.4   29 Mar 1996 08:19:42   jhuckins
// operator new with default POL_TYPE arg doesn't resolve correctly for default
// case, so added operator new with no POOL_TYPE arg which allocates 
// NonPagedPool type memory.
// 
//    Rev 1.3   29 Mar 1996 07:56:12   jhuckins
// Added default POOL_TYPE arg to operator new.  Default is NonPagedPool
// 
//    Rev 1.2   27 Mar 1996 14:13:22   JDELLIOT
// added PVCS keywords and support for warning level 4
//



