////////////////////////////////////////////////////////////////////////////////
// $Header:   S:\3x\src\ntkm\ntdevpp\sampdrv\object.cpv   1.0   24 Jun 1996 16:24:26   JHUCKINS  $
// 
// INTEL Corporation Proprietary Information
// 
// This listing is supplied under the terms of a license agreement
// with INTEL Corporation and may not be copied nor disclosed except
// in accordance with the terms of that agreement.
// 
// Copyright (c) 1996 Intel Corporation. All rights reserved.
// 
// $Revision:   1.0  $
// $Date:   24 Jun 1996 16:24:26  $
// $Author:   JHUCKINS  $
// 
// Log at end of file.
// 
// Module Name:	object.cpp
// Author:		Jeff Huckins
// Abstract:	CObject implementation
// Environment:	Windows NT 3.51/4.0, MS Visual C++ 4.x
// Notes:
// 
////////////////////////////////////////////////////////////////////////////////

#pragma warning( disable: 4201 )	// nonstandard extension used : nameless struct/union
#pragma warning( disable: 4514 )	// unreferenced inline function has been removed
#pragma warning( disable: 4711 )	// function 'function' selected for automatic inline expansion

#include <idrivrpp.h>
#include "debug.h"

////////////////////////////////////////////////////////////////////////////////
// CObject Implementation
////////////////////////////////////////////////////////////////////////////////

////////////////////////////////////////////////////////////////////////////////
// ctor
CObject::~CObject()
{
	// close the handle
	Close();

	// @@@ we could call close here if close deref'd the object pointer
	if( NULL != m_ObjectPtr )
	{
		ObDereferenceObject( m_ObjectPtr );
	}

	return;
}

NTSTATUS CObject::ReferenceObjectByHandle(
	IN ACCESS_MASK DesiredAccess,
	IN POBJECT_TYPE ObjectType /* = NULL */,
	IN KPROCESSOR_MODE AccessMode /* = KernelMode */,
	IN POBJECT_HANDLE_INFORMATION HandleInformation /* = NULL */,
	IN BOOLEAN CloseHandle /* = TRUE */,
	OUT NTSTATUS* CloseStatus /* = NULL */ )
{
	if( NULL != m_ObjectPtr || NULL == m_Handle )
	{
		return STATUS_INVALID_HANDLE;
	}

	NTSTATUS Status = ObReferenceObjectByHandle(
		m_Handle,
		DesiredAccess,
		ObjectType,
		AccessMode,
		&m_ObjectPtr,
		HandleInformation );

	// Should we close the handle?
	if( TRUE == CloseHandle )
	{
		if( NULL != CloseStatus )
		{
			*CloseStatus = Close();
		}
		else
		{
			Close();
		}
	}

	return Status;
}

NTSTATUS CObject::GetObjectPtr( IN PVOID& Object )
{
	Object = NULL;
	return STATUS_NOT_SUPPORTED;
}

BOOLEAN CObject::IsValid( void )
{
	return BOOLEAN( NULL != m_Handle || NULL != m_ObjectPtr );
}

////////////////////////////////////////////////////////////////////////////////
// CFileObject Implementation
////////////////////////////////////////////////////////////////////////////////

NTSTATUS CFileObject::Create(
	IN ACCESS_MASK DesiredAccess,
	OUT PIO_STATUS_BLOCK IoStatusBlock,
	IN ULONG FileAttributes /* = FILE_ATTRIBUTE_NORMAL */,
	IN ULONG ShareAccess /* = FILE_SHARE_READ | FILE_SHARE_WRITE */,
	IN ULONG CreateDisposition /* = FILE_OPEN_IF */,
	IN ULONG CreateOptions /* = FILE_DIRECTORY_FILE */ )
{
	OBJECT_ATTRIBUTES ObjectAttributes;
	InitializeObjectAttributes(
		&ObjectAttributes,
		GetName(),
		OBJ_CASE_INSENSITIVE | OBJ_OPENIF,
		NULL,	// RootDirectory
		NULL );	// pSecurityDescriptor

	return ZwCreateFile(
		&m_Handle,
		DesiredAccess,
		&ObjectAttributes,
		IoStatusBlock,
		NULL,	// Allocation size
		FileAttributes,
		ShareAccess,
		CreateDisposition,
		CreateOptions,
		NULL,	// EaBuffer
		0 );	// EaLength
}

/////////////////////////////////////////////////////////////////////////////
// $Log:   S:\3x\src\ntkm\ntdevpp\sampdrv\object.cpv  $
// 
//    Rev 1.0   24 Jun 1996 16:24:26   JHUCKINS
// Initial revision.
// 
//    Rev 1.6   03 Jun 1996 07:47:12   JHUCKINS
// Added Author to file header
// 
//    Rev 1.5   31 May 1996 15:50:48   JDELLIOT
// added robustness features (ASSERT, TRACE, validation of params)
// cleanup
// restructure of some interfaces
// 
